﻿/*
        * triangleBySides.jsx
        *
         Description: Draw a triangle given the length of its three sides.
         Simple! ::
        * dvb2008
        */
     
     #include "../shared/ominoDialogMaker.jsx"
     
      
      // this variable goes outside the main brackets to keep the
      // most recent dialog values.
      var gLastSettings;
      
      {
      var docCount = documents.length;
      
      if (docCount == 0)
      {
         documents.add();
      }
      
      
      
      function layerByName(layers,name)
      {
          var i;
          for(i = 0; i < layers.length; i++)
          {
              var layer = layers[i];
              if(layer.name == name)
                  return layer;
          }
          return null;
      }
      
      
      function newLayer(doc,baseName)
      {
          var n = 0;
          var result = null;
          while(result == null)
          {
              n++;
              var aName = "" + baseName + n;
              var existingLayer = layerByName(doc.layers,aName);
              if(existingLayer == null)
              {
                  result = doc.layers.add();
                  result.name = aName;
              }
          }
          return result;
      }
      
      function addP(points,x,y)
      {
          var p = points.add();
          p.anchor = [x,y];
          p.leftDirection = p.anchor;
          p.rightDirection = p.anchor;
      }
      
      function main()
      {
          var docRef = documents[0];
          var docHeight = docRef.height;
          var docWidth = docRef.width;
      
      
          // default values
          var cx = docWidth / 2;
          var cy = docHeight / 2;
      
          var omd = newOminoDialog("Triangle By Sides");
      
          
      
      
          omd.boxedText(5,"This Illustrator script draws a triangle, given the lengths of 3 sides.");
          omd.separator();
          omd.number("Center X","cx",cx);
          omd.number("Y","cy",cy);
          omd.gap();
          omd.number("Base (a)","a",100);
          omd.number("Left (b)","b",100);
          omd.number("Right (c)","c",100);
          
          omd.set(gLastSettings);
          var result = omd.run();
          
          if(result)
              gLastSettings = result;
      
          if(!result)
              return; // canceled
      
          cx = result.cx;
         cy = result.cy;
     
         a = result.a;
         b = result.b;
         c = result.c;
     
         var x = (a * a + b * b - c * c) / (2 * a);
         var y = Math.sqrt(b * b - x * x);
     
         x += cx;
         y += cy;
     
         var layer = newLayer(app.documents[0],"triangle_");
         
         var pathItem = layer.pathItems.add();
         var points = pathItem.pathPoints; // brand new, empty
     
         addP(points,cx,cy);
         addP(points,x,y);
         addP(points,cx + a,cy);
         
         pathItem.closed = true;
         pathItem.name = "triangle (" + a + "," + b + "," + c + ")";
     
     }
     
     main();
     }
     
     
